%define _lto_cflags -flto -ffat-lto-objects -flto-partition=none
%global sysmodprobedir %{_prefix}/lib/modprobe.d

%global alsa_ucm_version  1.2.9
%global alsa_tplg_version 1.2.5
%global source_url ftp://ftp.alsa-project.org/
 
Summary:       The Advanced Linux Sound Architecture (ALSA) library
Name:          alsa-lib
Version:       1.2.9
Release:       2%{?dist}
License:       LGPLv2+
URL:           http://www.alsa-project.org/
Source0:       %{source_url}pub/lib/%{name}-%{version}.tar.bz2
Source1:       %{source_url}pub/lib/alsa-ucm-conf-%{alsa_ucm_version}.tar.bz2
Source2:       %{source_url}pub/lib/alsa-topology-conf-%{alsa_tplg_version}.tar.bz2
Source3:       asound.conf
Source4:       modprobe-dist-alsa.conf
Source5:       modprobe-dist-oss.conf 

Patch3000:     alsa-lib-1.2.3.1-config.patch
Patch3001:     alsa-lib-1.0.14-glibc-open.patch

BuildRequires: make
BuildRequires: autoconf automake libtool

 
%description
This package includes the ALSA (The Advanced Linux Sound Architecture) 
runtime libraries to simplify application programming and provide higher 
level functionality as well as support forthe older OSS API, 
providing binary compatibility for most OSS programs.

The ALSA provides audio and MIDI functionality to the Linux operating system.

%package  devel
Summary:      Development files from the ALSA library
Requires:     %{name} = %{version}-%{release}
Requires:     pkgconfig

%description devel
This package includes the ALSA development libraries for developing
against the ALSA libraries and interfaces.

%package -n alsa-ucm
Summary:      ALSA Use Case Manager configuration
License:      BSD
BuildArch:    noarch
Requires:     %{name} >= %{version}

%description -n alsa-ucm
The Advanced Linux Sound Architecture (ALSA) Use Case Manager configuration
contains alsa-lib configuration of Audio input/output names and routing

%package  -n alsa-topology
Summary:      ALSA Topology configuration
License:      BSD
BuildArch:    noarch
Requires:     %{name} >= %{version}

%description -n alsa-topology
The Advanced Linux Sound Architecture (ALSA) topology configuration
contains alsa-lib configuration of SoC topology
 
%prep
%autosetup -p1
 
%build
autoreconf -vif
%configure --disable-aload --with-plugindir=%{_libdir}/alsa-lib --disable-alisp

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
 
%make_build
 
%install
%make_install

mkdir -p -m 755 %{buildroot}/etc
install -p -m 644 %{SOURCE3} %{buildroot}/etc

mkdir -p -m 755 %{buildroot}%{sysmodprobedir}
install -p -m 644 %{SOURCE4} %{buildroot}%{sysmodprobedir}/dist-alsa.conf
install -p -m 644 %{SOURCE5} .

mkdir -p %{buildroot}/%{_datadir}/alsa/ucm
mkdir -p %{buildroot}/%{_datadir}/alsa/ucm2
tar jxvf %{SOURCE1} -C %{buildroot}/%{_datadir}/alsa --strip-components=1 "*/ucm" "*/ucm2"
 
mkdir -p %{buildroot}/%{_datadir}/alsa/topology
tar jxvf %{SOURCE2} -C %{buildroot}/%{_datadir}/alsa --strip-components=1 "*/topology"

find %{buildroot} -name '*.la' -delete

rm %{buildroot}/%{_includedir}/asoundlib.h
 
%files
%license COPYING
%doc doc/asoundrc.txt modprobe-dist-oss.conf
%config %{_sysconfdir}/asound.conf
/%{_libdir}/libasound.so.*
/%{_libdir}/libatopology.so.*
%{_bindir}/aserver
%{_datadir}/alsa/
%exclude %{_datadir}/alsa/ucm
%exclude %{_datadir}/alsa/ucm2
%exclude %{_datadir}/alsa/topology
%{sysmodprobedir}/dist-*
 
%files devel
%doc TODO 
%{_includedir}/alsa/
%{_includedir}/sys/asoundlib.h
%{_libdir}/libasound.so
%{_libdir}/libatopology.so
%{_libdir}/pkgconfig/alsa.pc
%{_libdir}/pkgconfig/alsa-topology.pc
%{_datadir}/aclocal/alsa.m4
 
%files -n alsa-ucm
%{_datadir}/alsa/ucm
%{_datadir}/alsa/ucm2
 
%files -n alsa-topology
%{_datadir}/alsa/topology
 
%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.9-2
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Jul 03 2023 kianli <kianli@tencent.com> - 1.2.9-1
- Upgrade to 1.2.9

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.8-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.2.8-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Dec 1 2022 Feng Weiyao <wynnfeng@tencent.com> - 1.2.8-1
- update to 1.2.8

* Fri Sep 16 2022 Yi Lin <nilusyi@tencent.com> - 1.2.7.2-1
- package init.
